﻿using UnityEngine;
using UnityEditor;

[InitializeOnLoad]
static class RotationGizmo
{
	static RotationGizmo()
	{
		SceneView.onSceneGUIDelegate += OnSceneGUI;
	}
	
	static void OnSceneGUI(SceneView sceneView)
	{
		// Only display when the Rotate tool is selected.
		if (Tools.current != Tool.Rotate)
			return;

		// Only display when the Local rotation mode is active.
		if (Tools.pivotRotation != PivotRotation.Local)
			return;

		var position = Tools.handlePosition;
		var rotation = Tools.handleRotation;

		DrawAxis(position, rotation * Vector3.right, Handles.xAxisColor);
		DrawAxis(position, rotation * Vector3.up, Handles.yAxisColor);
		DrawAxis(position, rotation * Vector3.forward, Handles.zAxisColor);
	}

	static void DrawAxis(Vector3 position, Vector3 direction, Color color)
	{
		var alpha = new Color (1, 1, 1, 0.5f);
		Handles.color = color * alpha;

		var size = HandleUtility.GetHandleSize(position) * 0.5f;
		Handles.ArrowCap(-1, position, Quaternion.LookRotation (direction), size);
	}
}
